#Installs Packages
install.packages("bnlearn")
source("http://bioconductor.org/biocLite.R")
biocLite(c("graph", "Rgraphviz"))

#Loads Library
library(bnlearn)

#Importing and Prepping
data = read.csv(file = "C:/Users/berna/OneDrive/Desktop/Fall 2019 Project/CCGrade100Genes.csv", header = TRUE, sep=",")
bn_df = data.frame(data)
bn_df[1:101] = lapply(bn_df[1:101], as.factor)

#Running
start_time_mmhc = Sys.time() 
mmhc = mmhc(bn_df)
end_time_mmhc = Sys.time()

start_time_gs = Sys.time() 
gs = gs(bn_df)
end_time_gs = Sys.time()

start_time_hc = Sys.time() 
hc = hc(bn_df)
end_time_hc = Sys.time()

#Visualizing
arcs(mmhc)
graphviz.plot(mmhc)

arcs(gs)
graphviz.plot(gs)

arcs(hc)
graphviz.plot(hc)

#Cross Validation
start_time_1 = Sys.time() 
bn.cv(bn_df, bn = "mmhc", k = 10)
end_time_1 = Sys.time()

start_time_2 = Sys.time() 
bn.cv(bn_df, bn = "gs", k = 10)
end_time_2 = Sys.time()

start_time_3 = Sys.time() 
bn.cv(bn_df, bn = "hc", k = 10)
end_time_3 = Sys.time()
warnings()